using at.jku.ssw.Analyse;

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text;
using System.IO;

namespace at.jku.ssw.Analyse.GUI
{
	/// <summary>
	/// Summary description for MainFrm.
	/// </summary>
	public class MainFrm : System.Windows.Forms.Form
	{
		private String sFileName;
		private String sFullFileName;
		private RootInfo riAnalysed;

		private System.Windows.Forms.MenuItem menuFile;
		private System.Windows.Forms.MenuItem menuFileOpen;
		private System.Windows.Forms.MenuItem menuFileSave;
		private System.Windows.Forms.MenuItem menuFileExport;
		private System.Windows.Forms.MenuItem menuHelp;
		private System.Windows.Forms.MenuItem menuHelpAbout;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.OpenFileDialog openFileDialog;
		private InfoPanel mainCtrl;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuFileExit;
		private System.Windows.Forms.TreeView mainTree;
		private System.Windows.Forms.Splitter splitter;
		private System.Windows.Forms.Label lblCaption;
		private System.Windows.Forms.SaveFileDialog saveFileDialog;
		private System.Windows.Forms.ImageList mainImgList;
		private System.ComponentModel.IContainer components;

		public MainFrm()
		{
			riAnalysed = null;
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainFrm));
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.menuFile = new System.Windows.Forms.MenuItem();
			this.menuFileOpen = new System.Windows.Forms.MenuItem();
			this.menuFileSave = new System.Windows.Forms.MenuItem();
			this.menuFileExport = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuFileExit = new System.Windows.Forms.MenuItem();
			this.menuHelp = new System.Windows.Forms.MenuItem();
			this.menuHelpAbout = new System.Windows.Forms.MenuItem();
			this.mainTree = new System.Windows.Forms.TreeView();
			this.mainImgList = new System.Windows.Forms.ImageList(this.components);
			this.splitter = new System.Windows.Forms.Splitter();
			this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.lblCaption = new System.Windows.Forms.Label();
			this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
			this.SuspendLayout();
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuFile,
																					 this.menuHelp});
			// 
			// menuFile
			// 
			this.menuFile.Index = 0;
			this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuFileOpen,
																					 this.menuFileSave,
																					 this.menuFileExport,
																					 this.menuItem1,
																					 this.menuFileExit});
			this.menuFile.Text = "&File";
			// 
			// menuFileOpen
			// 
			this.menuFileOpen.Index = 0;
			this.menuFileOpen.Text = "&Open...";
			this.menuFileOpen.Click += new System.EventHandler(this.menuFileOpen_Click);
			// 
			// menuFileSave
			// 
			this.menuFileSave.Enabled = false;
			this.menuFileSave.Index = 1;
			this.menuFileSave.Text = "&Save...";
			this.menuFileSave.Click += new System.EventHandler(this.menuFileSave_Click);
			// 
			// menuFileExport
			// 
			this.menuFileExport.Enabled = false;
			this.menuFileExport.Index = 2;
			this.menuFileExport.Text = "&Export to Source File...";
			this.menuFileExport.Click += new System.EventHandler(this.menuFileExport_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 3;
			this.menuItem1.Text = "-";
			// 
			// menuFileExit
			// 
			this.menuFileExit.Index = 4;
			this.menuFileExit.Text = "&Exit";
			this.menuFileExit.Click += new System.EventHandler(this.menuFileExit_Click);
			// 
			// menuHelp
			// 
			this.menuHelp.Index = 1;
			this.menuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuHelpAbout});
			this.menuHelp.Text = "&?";
			// 
			// menuHelpAbout
			// 
			this.menuHelpAbout.Index = 0;
			this.menuHelpAbout.Text = "&About...";
			this.menuHelpAbout.Click += new System.EventHandler(this.menuHelpAbout_Click);
			// 
			// mainTree
			// 
			this.mainTree.Dock = System.Windows.Forms.DockStyle.Left;
			this.mainTree.ImageList = this.mainImgList;
			this.mainTree.Name = "mainTree";
			this.mainTree.Size = new System.Drawing.Size(248, 414);
			this.mainTree.TabIndex = 0;
			this.mainTree.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.mainTree_AfterSelect);
			// 
			// mainImgList
			// 
			this.mainImgList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.mainImgList.ImageSize = new System.Drawing.Size(16, 16);
			this.mainImgList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("mainImgList.ImageStream")));
			this.mainImgList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// splitter
			// 
			this.splitter.Location = new System.Drawing.Point(248, 0);
			this.splitter.Name = "splitter";
			this.splitter.Size = new System.Drawing.Size(3, 414);
			this.splitter.TabIndex = 1;
			this.splitter.TabStop = false;
			// 
			// openFileDialog
			// 
			this.openFileDialog.DefaultExt = "cs";
			this.openFileDialog.Filter = "C# files(*.cs)|*.cs";
			this.openFileDialog.Title = "Choose File to analyse...";
			// 
			// lblCaption
			// 
			this.lblCaption.Dock = System.Windows.Forms.DockStyle.Top;
			this.lblCaption.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblCaption.Location = new System.Drawing.Point(251, 0);
			this.lblCaption.Name = "lblCaption";
			this.lblCaption.Size = new System.Drawing.Size(461, 23);
			this.lblCaption.TabIndex = 2;
			this.lblCaption.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// saveFileDialog
			// 
			this.saveFileDialog.DefaultExt = "txt";
			this.saveFileDialog.Filter = "Text Files|*.txt";
			this.saveFileDialog.Title = "Choose File to save...";
			// 
			// MainFrm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(712, 414);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lblCaption,
																		  this.splitter,
																		  this.mainTree});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu;
			this.Name = "MainFrm";
			this.Text = "C# Analyse GUI";
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() {
			Application.Run(new MainFrm());
		}

		private void fillTreeView(TreeNodeCollection col, CodeInfo ci) {
			CodeInfoTreeNode citn = new CodeInfoTreeNode(ci);
			col.Add(citn);
			foreach(CodeInfo ciTmp in ci.children) {
				fillTreeView(citn.Nodes, ciTmp);
			}
		}

		/// <summary>
		/// Der Benutzer hat auf File--Open geklickt.
		/// </summary>
		private void menuFileOpen_Click(object sender, System.EventArgs e) {
			if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
				riAnalysed = new RootInfo("Root Node", 0, null);
	
				StringBuilder sb = new StringBuilder();
				Scanner scanner = new Scanner(riAnalysed, openFileDialog.FileName);
				Parser parser = new Parser(riAnalysed, scanner);
				try{
					parser.Parse();
					scanner.buffer.Close();
				}
				catch (Exception exc) {
					sb.AppendFormat("Exception occured: {0}\n", exc.Message);
				}
				if (parser.errors.count > 0) {
					sb.Append("Errors occured:\n");
					while(parser.errors.encounteredErrors.Count>0)
						sb.AppendFormat("  {0}\n", parser.errors.encounteredErrors.Dequeue());
				}
				if (sb.Length>0)
					MessageBox.Show("The gathered data may be not correct!\n"+sb.ToString(),
						"Errors occured!",
						MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				sFullFileName = openFileDialog.FileName;
				int ind = openFileDialog.FileName.LastIndexOf("\\");
				if (ind == -1) sFileName = openFileDialog.FileName;
				else sFileName = openFileDialog.FileName.Substring(ind+1);
				this.Text = "C# Analyse GUI - " + sFileName;
				riAnalysed.compute();
				mainTree.BeginUpdate();
				mainTree.Nodes.Clear();
				fillTreeView(mainTree.Nodes, riAnalysed);
				mainTree.EndUpdate();
				updateMainView();
				menuFileSave.Enabled = true;
				menuFileExport.Enabled = true;
			}
		}

		/// <summary>
		/// Der Benutzer hat auf File--Save geklick
		/// </summary>
		private void menuFileSave_Click(object sender, System.EventArgs e) {
			int iInd = sFileName.LastIndexOf(".");
			if (iInd != -1)
				saveFileDialog.FileName = sFileName.Substring(0, iInd);
			else
				saveFileDialog.FileName = sFileName;
			if (saveFileDialog.ShowDialog(this) == DialogResult.OK) {
				try{
					StreamWriter sw = File.CreateText(saveFileDialog.FileName);
					sw.WriteLine("--- RESULTS FROM THE ANALYSE OF {0} ---", sFileName);
					sw.Write(new String('-', sFileName.Length));
					sw.WriteLine("------------------------------------\n");

					sw.Write(riAnalysed.ToString());
					sw.Close();
				}
				catch (Exception exp) {
					MessageBox.Show("Error while writing to the file!\n"+exp.Message,
						"Errors occured!",
						MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				}
			}
		}

		private CodeInfo findLineInfo(CodeInfo ci, int line) {
			CodeInfo ret;
			if (ci.iLine == line)
				return ci;
			foreach (CodeInfo child in ci.children)
				if ((ret = findLineInfo(child, line)) != null)
					return ret;
			return null;
		}

		private String makeInfoComment(CodeInfo ci) {
			StringBuilder sb = new StringBuilder();
			sb.Append("/*<ANALYSE_BEGIN> (Do not change this line!)\n");
			sb.Append("//  ***** ANALYSED CODE INFO *****\n");
			sb.Append(ci.ToString("  ", false));
			sb.Append("<ANALYSE_END> (Do not change this line!)*/\n");
			return sb.ToString();
		}

		/// <summary>
		/// Der Benutzer hat auf File--Export geklickt.
		/// </summary>
		private void menuFileExport_Click(object sender, System.EventArgs e) {
			int line = 0;

			ChooseExports chExp = new ChooseExports();
			if (chExp.ShowDialog(this) == DialogResult.OK) {
				try {
					String sBakFile = Path.GetTempFileName();
					File.Delete(sBakFile);
					File.Move(sFullFileName, sBakFile);
					StreamWriter sw = File.CreateText(sFullFileName);
					StreamReader rw = File.OpenText(sBakFile);
					String sText;
					bool bOutput = true;
					CodeInfo ciInsert = findLineInfo(riAnalysed, line);
					if (ciInsert != null) {
						if ((ciInsert.GetType() == typeof(RootInfo) &&
							chExp.cbFileinfo.Checked) ||
							(ciInsert.GetType() == typeof(NamespaceInfo) &&
							chExp.cbNamespaceinfo.Checked) ||
							(ciInsert.GetType() == typeof(ClassInfo) &&
							chExp.cbClassinfo.Checked) ||
							(ciInsert.GetType() == typeof(MethodInfo) &&
							chExp.cbMethodinfo.Checked)) {
							sw.Write(makeInfoComment(ciInsert));
						}
					}
					while ((sText = rw.ReadLine()) != null) {
						if (sText.IndexOf("<ANALYSE_BEGIN>") != -1) bOutput = false;
						line++;
						ciInsert = findLineInfo(riAnalysed, line);
						if (ciInsert != null) {
							if ((ciInsert.GetType() == typeof(RootInfo) &&
								chExp.cbFileinfo.Checked) ||
								(ciInsert.GetType() == typeof(NamespaceInfo) &&
								chExp.cbNamespaceinfo.Checked) ||
								(ciInsert.GetType() == typeof(ClassInfo) &&
								chExp.cbClassinfo.Checked) ||
								(ciInsert.GetType() == typeof(MethodInfo) &&
								chExp.cbMethodinfo.Checked)) {
								sw.Write(makeInfoComment(ciInsert));
							}
						}
						if (bOutput)
							sw.WriteLine(sText);
						if (sText.IndexOf("<ANALYSE_END>") != -1) bOutput = true;
					}
					sw.Close();
					rw.Close();
					File.Delete(sBakFile);
				}
				catch (Exception exp) {
					MessageBox.Show("Error while reading/writing the files!\n"+exp.Message,
						"Errors occured!",
						MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				}
				menuFileExport.Enabled = false;
			}
		}

		/// <summary>
		/// Der Benutzer hat auf File--Exit geklickt.
		/// </summary>
		private void menuFileExit_Click(object sender, System.EventArgs e) {
			Application.Exit();
		}

		/// <summary>
		/// Der Benutzer whlt einen Eintrag in dem TreeView aus. Die Ausgabe muss
		/// demendsprechend angepasst werden.
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void mainTree_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e) {
			updateMainView();
		}

		private void updateMainView() {
			CodeInfoTreeNode citn = (mainTree.SelectedNode != null &&
									mainTree.SelectedNode.GetType() == typeof(CodeInfoTreeNode)) ?
																(CodeInfoTreeNode) mainTree.SelectedNode : null;
			this.SuspendLayout();
			this.Controls.Remove(mainCtrl);
			if (citn != null) {
				int tabIndex = -1;
				if (mainCtrl != null)
					tabIndex = mainCtrl.getTabIndex();
				if (citn.GetData().GetType() == typeof(RootInfo)) {
					this.mainCtrl = new RootInfoPanel((RootInfo)citn.GetData(), tabIndex);
					lblCaption.Text = "File: " + sFileName;
				}
				else if (citn.GetData().GetType() == typeof(NamespaceInfo)) {
					this.mainCtrl = new NamespaceInfoPanel((NamespaceInfo)citn.GetData(), tabIndex);
					lblCaption.Text = "Namespace: " + citn.GetData().sName;
				}
				else if (citn.GetData().GetType() == typeof(ClassInfo)) {
					this.mainCtrl = new ClassInfoPanel((ClassInfo)citn.GetData(), tabIndex);
					lblCaption.Text = "Class: " + citn.GetData().sName;
				}
				else if (citn.GetData().GetType() == typeof(MethodInfo)) {
					this.mainCtrl = new MethodInfoPanel((MethodInfo)citn.GetData(), tabIndex);
					lblCaption.Text = "Method: " + citn.GetData().sName;
				}
				else {
					lblCaption.Text = "";
					this.ResumeLayout();
					return;
				}
				this.mainCtrl.Dock = System.Windows.Forms.DockStyle.Fill;
				this.mainCtrl.Name = "mainCtrl";
				this.Controls.Add(mainCtrl);
				this.Controls.SetChildIndex(mainCtrl, 0);
			}
			else {
				lblCaption.Text = "";
			}
			this.ResumeLayout();
		}

		private void menuHelpAbout_Click(object sender, System.EventArgs e) {
			Help help = new Help();
			help.ShowDialog();
		}
	}
}
