using System;

namespace at.jku.ssw.Analyse {
	/// <summary>
	/// Diese Klasse speichert die Informationen einer Variable
	/// </summary>
	public class VariableInfo {
		public String sName; // Name der Variable
		public String sTyp; // Names des Typen, so wie er im Code steht
		private CodeInfo parent; // Deklarations-Bereich der Variable (Methode, Klasse)
		private ClassInfo ciTyp; // ClassInfo Objekt des Typen, falls dieser gefunden wurde (existiert)
		private bool bTypSearched; // Wurde der Typ bereits gesucht?

		public VariableInfo(String sName, String sTyp, CodeInfo parent) {
			this.sName = sName;
			this.sTyp = sTyp;
			this.parent = parent;
			this.ciTyp = null;
			this.bTypSearched = false;
		}

		public String getFullName() {
			return parent.getFullName() + "." + sName + ":" + sTyp;
		}

		public override String ToString() {
			return sTyp + " " + sName;
		}

		/// <summary>
		/// Diese Methode sucht nach dem CodeInfo-Objekt des Typen dieser Variable. Dieses muss nicht
		/// unbedingt gefunden werde knnen (z.B. bei int, float, etc.). Um mehrfaches Suchen zu vermeiden,
		/// wird das Flag bTypSearched am Ende der Suche gesetzt.
		/// </summary>
		public ClassInfo findTyp() {
			if (bTypSearched) return ciTyp;
			ciTyp = parent.findClassNFN(sTyp);
			bTypSearched = true;
			return ciTyp;
		}
	}
}
